<template>
  <div class="buy-tokens">
    <div
      v-if="form.status === 'default'"
      class="buy-tokens-form"
      v-loading="form.loading"
    >
      <div>
        <div class="label">USDT {{ $t('to_buy') }}</div>
        <el-input
          border
          v-model="form.amount"
          v-mask="{
            alias: 'numeric',
            groupSeparator: ',',
            autoGroup: true,
            digits: 2,
            allowMinus: false
          }"
        >
          <svg-icon name="ULUS" width="24" height="24" slot="prefix" />
        </el-input>
      </div>
      <div>
        <Button
          class="button buy-with-crypto"
          variant="bg"
          border="primary"
          @click="createCharge"
          v-if="!form.chargeUrl"
          :disabled="form.amount <= 0"
        >
          {{ $t('buy') }}
        </Button>
        <a
          class="buy-with-crypto"
          :href="form.chargeUrl"
          ref="buyWithCryptoButton"
        >
        </a>
        <script src="https://commerce.coinbase.com/v1/checkout.js?version=201807"></script>
      </div>
    </div>
    <div v-else></div>
    <!--
    <Steps :active="step">
      <Step />
      <Step />
      <Step />
    </Steps>

    <transition mode="out-in" name="fade-left">
      <div
        class="buy-step buy-step--0"
        v-if="step === 0"
        v-loading="form.loading"
      >
        <div class="amount">
          <div class="label">ULUS {{ $t('to_buy') }}</div>
          <el-input
            border
            v-model="form.amount"
            v-mask="{
              alias: 'numeric',
              groupSeparator: ',',
              autoGroup: true,
              digits: 2,
              allowMinus: false
            }"
          >
            <svg-icon name="ULUS" width="24" height="24" slot="prefix" />
          </el-input>
        </div>

        <div class="rate">
          <div class="label">
            {{ $t('exchange_rate') }}
            <Tooltip
              effect="ulu"
              placement="top"
              :content="$t('exchange_rate_tooltip')"
            >
              <svg-icon name="info" fill="#0065ff" width="24" height="24" />
            </Tooltip>
          </div>
          <ExchangeRate :amount="form.amount" />
        </div>

<div>
          <a
            class="buy-with-crypto"
            href="https://commerce.coinbase.com/checkout/41c00a5a-c661-4785-b366-07ffde6eb6fc"
          >
            {{ $t('next_step') }}
          </a>
          <script src="https://commerce.coinbase.com/v1/checkout.js?version=201807"></script>
        </div> 

        <Button
          class="button"
          variant="bg"
          border="primary"
          @click="createCharge"
          :disabled="form.amount <= 0"
        >
          {{ $t('next_step') }}
        </Button>
      </div>
      <div
        class="buy-step buy-step--1"
        v-if="step === 1"
        v-loading="form.loading"
      >
        <div class="select">
          <el-select
            border
            default-first-option
            value-key="page_id"
            v-model="form"
          >
            <el-option
              class="flex"
              value="MasterCard ****7366"
              label="MasterCard ****7366"
            >
              <span>MasterCard ****7366</span>
              <svg-icon name="close" class="delete-card" />
            </el-option>
            <el-option value="Add bank card" label="Add bank card">
              <div @change="modals.addCard = !modals.addCard">
                Add bank card
              </div>
            </el-option>
            <el-option value="Bitcoin" label="Bitcoin" />
            <el-option value="Ethereum" label="Ethereum" />
            <el-option
              v-for="payway in payways"
              :key="payway._id"
              :value="payway"
              :label="payway.info"
            />
          </el-select>
        </div>
        <Button
          class="button"
          variant="bg"
          border="primary"
          @click="processPayment"
        >
          {{ $t('next_step') }}
        </Button>
      </div>

      <div
        class="buy-step buy-step--2"
        v-if="step === 2"
        v-loading="form.loading"
      >
        <div v-html="form.paymentForm" ref="formRef"></div>
      </div>
      <div class="buy-step buy-step--3" v-if="step === 3">
        <div class="label center">payment status</div>
        <div class="status" :class="`status-${form.status}`">
          {{ $t(form.status) }}
        </div>
      </div>
    </transition>
    -->
    <Alert v-if="form.error" variant="danger">
      {{ form.error }}
    </Alert>
    <!--
    <portal to="modal">
      <Modal v-model="modals.addCard">
        <template slot="title">Add card</template>
        <template slot="description" class="blue bold">
          Easy way to buy tokens
        </template>
        <template slot="info">Note: you can delete it anytime</template>
        <div class="modal__input">
          <el-input
            border
            line
            v-model="addCard.number"
            placeholder="Card number"
          />
        </div>
        <div class="modal__input">
          <el-input border line v-model="addCard.name" placeholder="Name" />
        </div>
        <div class="modal__grid">
          <div>
            <div class="modal__input">
              <el-input
                border
                line
                v-model="addCard.expires"
                placeholder="Expires"
              />
            </div>
          </div>
          <div>
            <div class="modal__input">
              <el-input border line v-model="addCard.cvc" placeholder="CVC" />
            </div>
          </div>
        </div>
        <Button size="small" @click="modals.addCard = !modals.addCard">
          Save my card
          <svg-icon name="arrow-line" class="icon-radius" />
        </Button>
      </Modal>
    </portal>
    -->
  </div>
</template>

<script lang="ts">
import { defineComponent, reactive } from '@nuxtjs/composition-api'

// import ExchangeRate from '@/components/profile/wallet/ExchangeRate.vue'
// import Modal from '@/components/ui/Modal.vue'
import elInput from '@/components/element/Input.vue'
// import Steps from '@/components/element/Steps.vue'
// import Step from '@/components/element/Step.vue'
// import Tooltip from '@/components/element/Tooltip.vue'
import Button from '@/components/ui/Button.vue'
// import elSelect from '@/components/element/Select.vue'
// import elOption from '@/components/element/Option.vue'
import Alert from '@/components/ui/Alert.vue'

import { TransactionFragment } from '~/sdk/types'

type PaymentStatus = 'default' | 'processing' | 'success' | 'failure'

export default defineComponent({
  name: 'BuyTokens',
  components: {
    Alert,
    // Modal,
    // ExchangeRate,
    // Steps,
    // Step,
    // Tooltip,
    Button,
    elInput
    // elSelect,
    // elOption
  },
  setup(_, { root: { $axios } }) {
    const form = reactive({
      amount: 0,
      loading: false,
      transaction: null as TransactionFragment | null,
      status: 'default' as PaymentStatus,
      error: null as string | null,
      chargeUrl: null as string | null
    })

    // const step = ref(0)

    // const modals = ref({
    //   addCard: false
    // })

    // const addCard = reactive({
    //   number: '',
    //   name: '',
    //   expires: '',
    //   cvc: ''
    // })

    // const ModalAddCard = () => {
    //   if (form.selectedItem === 'Add Card') {
    //     modals.addCard = true
    //   }
    // }

    // watch(payways, value => {
    //   if (!form.selectedItem) form.selectedItem = value[0]
    // })

    // async function makePayment() {
    //   form.loading = true
    //   try {
    //     const { transaction, url } = await interkassa.makePayment(
    //       form.amount,
    //       'payways',
    //       form.transaction?.id
    //     )
    //     form.transaction = transaction
    //     const result = await interkassa.getPayways(url)
    //     if (result.resultMsg !== 'Success') throw new Error(result.resultMsg)
    //     payways.value = result.resultData.paywaySet
    //     form.error = null
    //     step.value = 1
    //   } catch (e) {
    //     form.error = e?.response?.data?.message || e?.message || 'error'
    //   }
    //   form.loading = false
    // }

    // async function processPayment() {
    //   if (!form.transaction || !form.selectedItem) return
    //   form.loading = true
    //   try {
    //     const { transaction, url } = await interkassa.makePayment(
    //       form.amount,
    //       'process',
    //       form.transaction.id,
    //       form.selectedItem.als
    //     )
    //     form.transaction = transaction
    //     const result = await interkassa.processPayment(url)
    //     form.status = result.resultMsg === 'Success' ? 'success' : 'failure'
    //     form.paymentForm = result.resultData.internalForm
    //     step.value = 2
    //   } catch (e) {
    //     form.error = e?.response?.data?.message || e?.message || 'error'
    //   }
    //   form.loading = false
    // }

    // const formRef = ref<HTMLElement | null>(null)
    // watch(formRef, value => {
    //   if (value) {
    //     const forms = value.getElementsByTagName('FORM')
    //     const payForm = forms.item(0) as HTMLFormElement
    //     if (payForm) {
    //       payForm.addEventListener('submit', async e => {
    //         e.preventDefault()
    //         const result = await $axios.$post(
    //           payForm.action,
    //           new FormData(payForm),
    //           {
    //             headers: {
    //               'Access-Control-Allow-Origin': '*'
    //             }
    //           }
    //         )
    //         console.log(result)
    //       })
    //     }
    //   }
    // })

    // const buyWithCryptoButton = ref<HTMLLinkElement>(null)

    const createCharge = async () => {
      try {
        form.loading = true
        const data = await $axios.$post<{ hosted_url: string }>(
          '/api/payments/coinbase/create-charge',
          {
            amount: form.amount
          }
        )
        form.chargeUrl = data.hosted_url
        form.loading = false
        form.error = null
      } catch (e) {
        form.error = e?.response?.data?.message || e?.message || 'error'
      }
    }

    return {
      // modals,
      // ModalAddCard,
      form,
      // addCard,
      // step,
      createCharge
    }
  }
})
</script>

<style lang="scss" scoped>
// ::v-deep .el-steps {
//   margin-bottom: 50px;
// }
.buy-tokens {
  .alert {
    margin-top: 1em;
  }

  .label {
    font-weight: bold;
    font-size: 18px;
    line-height: 23px;
    letter-spacing: 0.9px;
    color: #8591ad;
    text-transform: uppercase;
    margin-bottom: 20px;
    display: flex;
    align-items: center;
    &.center {
      justify-content: center;
    }

    svg {
      margin-left: 12px;
    }
  }

  &-form {
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: 30px 24px;
    align-items: flex-end;

    @media (min-width: 1199.98px) {
      grid-template-columns: 1fr 1fr;
    }
  }

  .status {
    color: #fff;
    font-weight: 500;
    font-size: 26px;
    line-height: 38px;
    text-align: center;
    margin-top: -5px;
    &-success {
      color: var(--color-success);
    }
    &-failure {
      color: var(--color-danger);
    }
    &-processing {
      color: var(--color-info);
    }
  }
}

//   .status {
//     color: #fff;
//     font-weight: 500;
//     font-size: 26px;
//     line-height: 38px;
//     text-align: center;
//     margin-top: -5px;
//     &-success {
//       color: var(--color-success);
//     }
//     &-failure {
//       color: var(--color-danger);
//     }
//     &-processing {
//       color: var(--color-info);
//     }
//   }

//   &--0 {
//     display: grid;
//     grid-template-areas: 'amount' 'rate' 'button';
//     grid-template-columns: 1fr;
//     grid-gap: 30px 24px;

//     @media (min-width: 1199.98px) {
//       grid-template-areas: 'amount rate' 'button button';
//       grid-template-columns: 1fr 1fr;
//       // grid-template-columns: 0.3fr 1fr;
//     }

//     .amount {
//       grid-area: amount;
//     }
//     .rate {
//       grid-area: rate;
//     }

//     .button {
//       grid-area: button;
//     }
//   }
//   &--1 {
//     .select {
//       margin-bottom: 30px;
//     }
//   }
// }
</style>
